#!/bin/bash

# commands
commandsNames=(	"Next Track"
			"Previous Track"
			"Pause/Play"
			"Cancel"
			"Cancel")

commandsExec=(	"dbus-send --type=method_call --dest=ru.somebody.someplayer / ru.somebody.someplayer.next"
			"dbus-send --type=method_call --dest=ru.somebody.someplayer / ru.somebody.someplayer.prev"
			"dbus-send --type=method_call --dest=ru.somebody.someplayer / ru.somebody.someplayer.toggle"
			""
			"")

# settings
grabScanInterval=0.3
holdScanInterval=0.3
openedNeededForExecution=1
operationWaitCycles=3

# script start

closed=0
opened=0
sleepTime=$grabScanInterval

newCycleStart=$((1+${#commandsNames[@]}*$operationWaitCycles))

while [ 1 ]
do
	if [ "$(cat /sys/devices/platform/gpio-switch/proximity/state)" = "closed" ]; then

		if [ $closed = 0 ]; then
			sleepTime=$holdScanInterval
			opened=0
		elif [ $closed = $newCycleStart ]; then
			closed=0
		fi
		closed=$(( $closed + 1 ))

		for ((i=1, j=0 ; j < ${#commandsNames[@]} ; i=i+$operationWaitCycles, j++))
		do
			if [ $closed = $i ]; then
				run-standalone.sh dbus-send --type=method_call --dest=org.freedesktop.Notifications /org/freedesktop/Notifications org.freedesktop.Notifications.SystemNoteInfoprint string:"${commandsNames[$j]}"
				break
			fi
		done
	else
		if [ $opened -ge $openedNeededForExecution ]; then
			for ((i=1+(${#commandsNames[@]}-1)*$operationWaitCycles, j=${#commandsNames[@]}-1 ; i > 0  ; i=i-$operationWaitCycles, j--))
			do
				if [ $closed -ge $i ]; then
					IFS=';' read -ra commands <<< "${commandsExec[$j]}"
					for command in "${commands[@]}"; do
						$command
					done
					break
				fi
			done

			closed=0
			opened=0
			sleepTime=$grabScanInterval
		fi
		if [ $closed != 0 ]; then
			opened=$(( $opened + 1 ))
		fi
	fi

	sleep $sleepTime
done
